//	name:		klammer.cpp
//	autor		Hong Phuc Bui		KIB-3464938
//                      (kleinere Anpassungen D. Weber 10.01.08)
//	datum		07.01.2008
//	copyleft	GNU
//	beschreibung	Stack simulieren durch Klammerverarbeitung
//	version		0.1

#include<iostream>
#include<unistd.h>
using namespace std;

const int MAX_ELEMENTS=8;
const int STATUS_ROW=MAX_ELEMENTS+5;


typedef char stackType; // der Stack verwaltet Daten dieses Typs

void set_cursor (int x, int y) //x : Spalte; y : Zeile
{
	printf("%c[%d;%dH",27,y,x);
}

void clear_screen() // ANSI-Escape-Sequenz f. Bildschirm loeschen
{
	cout << "\033[2J" << flush;
}

void bold_text_mode() // ANSI-Escape-Sequenz f. fettgedruckten Text
{
	cout << "\033[1m" << flush;
}

void reverse_text_mode() // ANSI-Escape-Sequenz f. invertierten Text
{
	cout << "\033[7m" << flush;
}

void normal_text_mode() // ANSI-Escape-Sequenz f. normal gedruckten Text
{
	cout << "\033[0m" << flush;
}

class stack
{
	public:
		void init();	// Initialisierung Array und Stackpointer
		bool is_full ();	// ueberprueft ob stack voll ist
		bool is_empty();	// ueberprueft ob stack leer ist
		bool pop (char &x);	// pop-Operation
		bool push (char x); // push-Operation
		bool peek (stackType &x); // peek=oberster Wert aus stack 
		void display (int left);// Stack ausgeben

	private:
		stackType a[MAX_ELEMENTS]; // gespeicherte Elemente
		int sp; 		   // Stackpointer
};

// Initialisierung von Array und Stackpointer
void stack::init()
{
	int j;

	for (j=0;j<MAX_ELEMENTS;j++)
		a[j]=0;

	sp = 0;
}

// Stack voll <=> true, sonst false
bool stack::is_full()
{
	if (sp == MAX_ELEMENTS)
	{
		return true;
	}
	else
	{
		return false;
	}
}

// Stack leer <=> true, sonst false
bool stack::is_empty()
{
	if (sp == 0)
	{
		return true;
	}
	else
	{
		return false;
	}
}

// push() Operation : erfolgreich <=> true, sonst false
bool stack::push( stackType x)
{
	if ( is_full() )
	{
		return false;
	}
	else
	{
		a[sp] = x;
		sp ++;
		return true;
	}
}

// pop() Operation : erfolgreich <=> true, sonst false
bool stack::pop( stackType &x)
{	
	if (is_empty())
	{
		return false;
	}
	else
	{
		sp--;
		x=a[sp];
		return true;
	}
}

// peek() Operation : erfolgreich <=> true, sonst false
// liefert oberstes Stack-Element
bool stack::peek(stackType &x)
{
	if (is_empty())
	{
		return false;
	}

	x=a[sp-1];

	return true;
}

// Zustand des Stacks anzeigen
void stack::display(int left)
{
	int top = 2;
	int bot = MAX_ELEMENTS + top;
	cout <<endl;
	for (int i = 0; i < MAX_ELEMENTS; i++)
	{
		set_cursor (left + 5, bot -i);
		if (i < sp )
		{
			cout <<"        [ " <<a[i] <<" ]";
		}else if (i == sp)
		{
			cout <<"     -->[   ]";
		}else
		{
			cout <<"        [   ]";
		}
	}
	set_cursor (left, bot +2);
	reverse_text_mode();
	if ( is_empty() )
	{
		cout <<"Zustand:  leer  ";
	}else if ( is_full() )
	{
		cout << "Zustand: voll  ";
	}else
	{
		cout << "Zustand: normal";
	}
	normal_text_mode();
}

int main()
{
	const int left = 55;
	stack s;
	stackType x, a;

	s.init();
	clear_screen();
	s.display(left);

	for ( ; ; ) // oder while (true) { ... }
	{
		set_cursor (1,1);
		cout << "STACK ("<<MAX_ELEMENTS<<" Elemente, "
			"Eingabe '(' oder ')' : " << flush;

		cin >> x;
		if (x == ')')
		{
			if ( s.pop(a) )
			{
				clear_screen();
				s.display(left);

			}
			else 
			{
				clear_screen();
				s.display(left);
				set_cursor (1,1);
				cout << "                   ";
				bold_text_mode();
				set_cursor(1,STATUS_ROW);
				cout <<"Stack leer, pop()=false";
				normal_text_mode();
			}
		}
		else if (x == '(')
		{
			if (s.push(x))
			{
				clear_screen();
				s.display(left);

			}else
			{
				clear_screen();
				s.display(left);
				bold_text_mode();
				set_cursor(1,STATUS_ROW);
				cout <<"Stack voll, push()=false";
				normal_text_mode();
			}
		}
		else
		{
			bold_text_mode();
			set_cursor(1,STATUS_ROW);
			cout << "Programmende                    ";
			normal_text_mode();
			sleep(2);
			break; // Programmende bei unbekannter Eingabe
		}
	}
	clear_screen();
	set_cursor(1,1);
	return 0;
}
